Package ghidra.app.plugin.assembler.sleigh.expr

# Class OperandValueSolver

java.lang.Object
ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver<OperandValue>
ghidra.app.plugin.assembler.sleigh.expr.OperandValueSolver

public class OperandValueSolver extends AbstractExpressionSolver<OperandValue>
Solves expressions of an operand value

These are a sort of named sub-expression, but they may also specify a shift in encoding.

- ## Field Summary

  ### Fields inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `dbg, solver`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `OperandValueSolver()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static PatternExpression`
  `getDefiningExpression(OperandSymbol sym)`
  Obtains the "defining expression"
  `int`
  `getInstructionLength(OperandValue ov)`
  Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.
  `MaskedLong`
  `getValue(OperandValue ov, Map<String,Long> vals, AssemblyResolvedPatterns cur)`
  Attempt to get a constant value for the expression
  `AssemblyResolution`
  `solve(OperandValue ov, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description)`
  Attempt to solve an expression for a given value
  `MaskedLong`
  `valueForResolution(OperandValue ov, Map<String,Long> vals, AssemblyResolvedPatterns rc)`
  Compute the value of the expression given the (possibly-intermediate) resolution

  ### Methods inherited from class ghidra.app.plugin.assembler.sleigh.expr.AbstractExpressionSolver

  `register`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### OperandValueSolver

    public OperandValueSolver()

- ## Method Details

  - ### getDefiningExpression

    public static PatternExpression getDefiningExpression(OperandSymbol sym)
    Obtains the "defining expression"

    This is either the symbols assigned defining expression, or the expression associated with its defining symbol.

    Returns:
      the defining expression, or null if neither is available

  - ### solve

    public AssemblyResolution solve(OperandValue ov, MaskedLong goal, Map<String,Long> vals, AssemblyResolvedPatterns cur, Set<SolverHint> hints, String description) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to solve an expression for a given value
    Specified by:
      `solve` in class `AbstractExpressionSolver<OperandValue>`
    Parameters:
      `ov` - the expression to solve
      `goal` - the desired value of the expression
      `vals` - values of defined symbols
      `hints` - describes techniques applied by calling solvers
      `description` - the description to give to resolved solutions
    Returns:
      the resolution
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### getValue

    public MaskedLong getValue(OperandValue ov, Map<String,Long> vals, AssemblyResolvedPatterns cur) throws NeedsBackfillException
    Description copied from class: `AbstractExpressionSolver`
    Attempt to get a constant value for the expression
    Specified by:
      `getValue` in class `AbstractExpressionSolver<OperandValue>`
    Parameters:
      `ov` - the expression
      `vals` - values of defined symbols
    Returns:
      the constant value, or null if it depends on a variable
    Throws:
      `NeedsBackfillException` - if the expression refers to an undefined symbol

  - ### getInstructionLength

    public int getInstructionLength(OperandValue ov)
    Description copied from class: `AbstractExpressionSolver`
    Determines the length of the subconstructor that would be returned had the expression not depended on an undefined symbol.

    This is used by the backfilling process to ensure values are written to the correct offset

    Specified by:
      `getInstructionLength` in class `AbstractExpressionSolver<OperandValue>`
    Parameters:
      `ov` - the expression
    Returns:
      the length of filled in token field(s).

  - ### valueForResolution

    public MaskedLong valueForResolution(OperandValue ov, Map<String,Long> vals, AssemblyResolvedPatterns rc)
    Description copied from class: `AbstractExpressionSolver`
    Compute the value of the expression given the (possibly-intermediate) resolution
    Specified by:
      `valueForResolution` in class `AbstractExpressionSolver<OperandValue>`
    Parameters:
      `ov` - the expression to evaluate
      `vals` - values of defined symbols
      `rc` - the resolution on which to evaluate it
    Returns:
      the result